/* 
 * File:   gdgelement.h
 * Author: Michal Hucik <hucik@ordoz.com>
 *
 * Created on 13. května 2019, 22:56
 * 
 * 
 * ----------------------------- License -------------------------------------
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * ---------------------------------------------------------------------------
 */


#ifndef GDGELEMENT_H
#define GDGELEMENT_H

#ifdef __cplusplus
extern "C" {
#endif

#include <glib.h>


    typedef enum en_GDGELEMENT_PORT_TYPE {
        GDGELEMENT_PORT_IN = 0,
        GDGELEMENT_PORT_OUT,
        GDGELEMENT_PORT_INOUT
    } en_GDGELEMENT_PORT_TYPE;


    typedef struct st_GDGELEMENT_PORT {
        char *name;
        char *search_name;
        int id;
        en_GDGELEMENT_PORT_TYPE type;
    } st_GDGELEMENT_PORT;


    typedef struct st_GDGELEMENT {
        char *name;
        char *description;
        int count_port;
        st_GDGELEMENT_PORT **port;
        int count_instance; // pouze pro statisticke ucely
    } st_GDGELEMENT;


    typedef struct st_GDGELEMENTS_ALL {
        int count_element;
        st_GDGELEMENT **element;
    } st_GDGELEMENTS_ALL;


    extern st_GDGELEMENTS_ALL* gdgelements_init ( void );
    extern void gdgelements_destroy ( st_GDGELEMENTS_ALL *elmall );

    extern st_GDGELEMENT* gdgelements_search_element_by_name ( st_GDGELEMENTS_ALL *elmall, const char *name );
    extern void gdgelement_register_part_instance ( st_GDGELEMENT *elm, void *part );
    extern st_GDGELEMENT_PORT* gdgelement_get_port_by_name ( st_GDGELEMENT *elm, char *port_name );

#ifdef __cplusplus
}
#endif

#endif /* GDGELEMENT_H */

