/* 
 * File:   gdgnet.h
 * Author: Michal Hucik <hucik@ordoz.com>
 *
 * Created on 13. května 2019, 21:45
 * 
 * 
 * ----------------------------- License -------------------------------------
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * ---------------------------------------------------------------------------
 */


#ifndef GDGNET_H
#define GDGNET_H

#ifdef __cplusplus
extern "C" {
#endif

#include <glib.h>
#include "gdgelement.h"


    typedef struct st_GDGNET_PIN {
        st_GDGELEMENT *element; /* pokud je NULL, tak se jedna o PIN */
        char *part_pin_name;
        int loc_x;
        int loc_y;
        int loc_z; /* pokud je u PIN uvedena hodnota 'z', tak se jedna o vnejsi GDG pin */
    } st_GDGNET_PIN;


    typedef struct st_GDGNET {
        char *name;
        gboolean is_constant;
        gboolean c_value;
        int count_pin;
        st_GDGNET_PIN **pin;
        int count_output; // v signalech mezi party s vyjimkou vdd a 0 musi byt vzdy '1', v PIN signalech nam identifikuje pin direction
        int count_externals; // pocet PIN pripojeni
    } st_GDGNET;


    typedef struct st_GDGNETS_ALL {
        int count_net;
        st_GDGNET **net;
    } st_GDGNETS_ALL;


    typedef struct st_GDGIOPORT {
        st_GDGNET_PIN *pin;
        st_GDGNET *net;
        char *vhdl_name;
    } st_GDGIOPORT;


    typedef struct st_GDGIOPORTS_ALL {
        int count_real;
        st_GDGIOPORT **real;
        int count_internal;
        st_GDGIOPORT **internal;
    } st_GDGIOPORTS_ALL;


    extern st_GDGNETS_ALL* gdgnets_init ( st_GDGELEMENTS_ALL *elmall, const char * filepath );
    extern void gdgnets_destroy ( st_GDGNETS_ALL *netall );

    extern st_GDGIOPORTS_ALL* gdgnets_create_ioports ( st_GDGNETS_ALL *netall );
    extern void gdgnets_ioports_destroy ( st_GDGIOPORTS_ALL *ioportall );

#ifdef __cplusplus
}
#endif

#endif /* GDGNET_H */

