/* 
 * File:   gdgpart.h
 * Author: Michal Hucik <hucik@ordoz.com>
 *
 * Created on 13. května 2019, 22:38
 * 
 * 
 * ----------------------------- License -------------------------------------
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * ---------------------------------------------------------------------------
 */


#ifndef GDGPART_H
#define GDGPART_H

#ifdef __cplusplus
extern "C" {
#endif

#include "gdgnet.h"


    typedef struct st_GDGPART {
        st_GDGELEMENT *element;
        int loc_x;
        int loc_y;
        st_GDGNET **netpin;
    } st_GDGPART;


    typedef struct st_GDGPARTS_ALL {
        int count_part;
        st_GDGPART **part;
        int min_loc_x;
        int min_loc_y;
        int max_loc_x;
        int max_loc_y;
        int xsize;
        int ysize;
        st_GDGPART **loc;
    } st_GDGPARTS_ALL;


    extern st_GDGPARTS_ALL* gdgparts_init ( st_GDGELEMENTS_ALL *elmall, const char *filepath );
    extern void gdgparts_destroy ( st_GDGPARTS_ALL *partall );
    extern st_GDGPART* gdgparts_get_part_by_location ( st_GDGPARTS_ALL *partall, int loc_x, int loc_y );
    extern char* gdgpart_create_name ( st_GDGPART *part );

#ifdef __cplusplus
}
#endif

#endif /* GDGPART_H */

