/* 
 * File:   vhdl.h
 * Author: Michal Hucik <hucik@ordoz.com>
 *
 * Created on 15. května 2019, 22:05
 * 
 * 
 * ----------------------------- License -------------------------------------
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * ---------------------------------------------------------------------------
 */


#ifndef VHDL_H
#define VHDL_H

#ifdef __cplusplus
extern "C" {
#endif

#include <glib.h>

    extern char* vhdl_create_entity_header ( st_GDGIOPORTS_ALL *sigall, const char * name );
    extern char* vhdl_create_components ( st_GDGELEMENTS_ALL *elmall, gboolean unused_elements );
    extern char* vhdl_create_signal_definitions ( st_GDGNETS_ALL *netall, const char *net_prefix );
    extern char* vhdl_create_entity_port_connections ( st_GDGIOPORTS_ALL *ioportall, st_GDGNETS_ALL *netall, const char *net_prefix );
    extern char* vhdl_create_component_instances ( st_GDGPARTS_ALL *partall, const char *part_prefix, const char *net_prefix );


#ifdef __cplusplus
}
#endif

#endif /* VHDL_H */

